#include<fstream>
using namespace std;
ifstream fi("BAI2_15.inp");
ofstream fo("BAI2_15.out");
int n;
int a[200];
int max;
int xl()
{
	int q=0;
	int max=0;
	int y=0;
	for(int i=0;i<n;i++)
	{
		q=0;
		for(int j=i;j<n;j++)
		{
			q+=a[j];
			if(q==0)
			{
				y=1;
				if((j-i+1)>max) max=(j-i+1);
			}
		}
	}
	if(y==1) return max;
	else return -1;
}
int main()
{
	fi>>n;
	for(int u=0;u<n;u++) fi>>a[u];
	int r=xl();
	if (r==-1) fo<<"NO SOLUTION";
	else fo<<r;
	fi.close();
	fo.close();
}

